<?php
/*
 * Copyright 2003-2008 Jamin W. Collins <jcollins@asgardsrealm.net>
 *
 * This file is part of Media Mate
 * 
 * Media Mate is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Media Mate is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Media Mate; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 */
/*
   this file is responsible for fetching and parsing information
   from IMDB's web site

   Tested successfully against IMDB 2007-12-31

   it requires the following parameters:
   - imdb_url
   
   it sets the following variables:
   - cover_art
   - imdb_year
   - plot, longest of the plots added by users
   - runtime
   - genre
   - director
   - actors
   - imdb rating (unused)
   - Top 250 rating (unused)
   
   update based on parsing patch from
   Joris Meijerink <meijerink@gmail.com> - 02/19/2007 11:57 AM

*/   

   if (! is_null($_POST['imdb_url'])) {
      $imdb_url = $_POST['imdb_url'];
      
      $snoopy = new Snoopy;

      $snoopy->fetch($imdb_url);
      $imdb_page = $snoopy->results;
      
      $snoopy->fetch($imdb_url."plotsummary");
      $imdb_plot = $snoopy->results;      
      
      if (ereg('name="poster"[^>]*>(<[^<]*)', $imdb_page, $temp)) {
         if (ereg('src="([^"]*)', $temp[1], $temp)) {
            $cover_art = $temp[1];
         };
      };

      if (eregi('<title>([^<]*))', $imdb_page, $temp)) {
         $temp = explode("(", $temp[1]);
         $title = trim($temp[0]);
         $imdb_year = trim($temp[1]);
      };

      $regex = '|<p class=\"plotpar\">([^<]+)<i>|';
      $count = preg_match_all($regex, $imdb_plot, $plots);
      for ($i = 0; $i < sizeof($plots[1]); $i++) {
         if (strlen($plot) < strlen($plots[1][$i])) {
            $plot = trim($plots[1][$i]);
         } 
      }

      if (eregi('Plot Outline:</h5>([^<]*)', $imdb_page, $temp) && ($plot == "")) {
         $plot = trim($temp[1]);
      };

      // works for movies with and without regional runtimes
      // but which regions runtime is desired????
      if (eregi('Runtime:</h5>[^:]*:([[:digit:]]+)', $imdb_page, $temp)) {
         $runtime = trim($temp[1]);
      } elseif (eregi('Runtime:</h5>([^ ]*)', $imdb_page, $temp)) {
         $runtime = trim($temp[1]);
      };

      if (eregi('Genre[^>]*>[^>]*>([^<]*)', $imdb_page, $temp)) {
         $genre = trim($temp[1]);
      };

      if (eregi('Genre[^>]*>[^>]*>[^>]*> / [^>]*>([^<]*)', 
         $imdb_page, $temp)) {
            $genre = $genre . ", " . trim($temp[1]);
      };

      if (eregi('Genre[^>]*>[^>]*>[^>]*> / [^>]*>[^>]*> / [^>]*>([^<]*)', 
         $imdb_page, $temp)) {
            $genre = $genre . ", " . trim($temp[1]);
      };

      if (eregi('Directors?:[^>]*>[^>]*>([^<]*)', $imdb_page, $temp)) {
         $director = trim($temp[1]);
      };

      if (eregi('Directors?:[^>]*>[^>]*>[^>]*><br/><a[^>]*>([^<]*)', 
         $imdb_page, $temp)) {
            $director = $director . ", " . trim($temp[1]);
      };

      if (eregi('User rating:([^>]*>){2}([^<]*)', $imdb_page, $temp)) {
        $rating = $temp[2]; 
        $rating = explode("/", $rating);        
        $rating = $rating[0];
      };

      if (eregi('Top 250: ([^<]*)', $imdb_page, $temp))  {
         $temp = explode("#", $temp[1]);
         $top250 = $temp[1];
      };
      
      $lines = file($imdb_url);
      for ($i = 0; $i < sizeof($lines)-1 ; $i++) {
         if (eregi('redited cast', trim($lines[$i]))) 
         {
            $cast = $i;
         }
         elseif (eregi('Cast overview, first billed only', trim($lines[$i]))) 
         {
            $cast = $i;
         }            
      }
      $cast = $lines[$cast];        
      $regex = '|<a href=\"/name[^"]+">([^<]+)</a>|';
      $count = preg_match_all($regex, $cast, $names);
      $actors = $names[1][0];  
      for ($i = 1; $i < sizeof($names[1]); $i++) {
         $actors .= ", ".$names[1][$i];
      }  

      # trim the returned actor list to 100 characters or less
      # so we don't exceed the database field limit
      if ( strlen($actors) > 100)
      {
         # chop it off at 100
         $actors = substr($actors, 0, 100);
         # find the last ", "
         $i = strrpos($actors, ', ');
         $actors = substr($actors, 0, $i);
      }
   };
?>
